<?php
/*
Plugin Name: Display vBulletin Node
Plugin URI: http://anybuy.vn/
Description: Display vBulletin Node is a WordPress plugin that allows you to show nodes from your separate vBulletin forum as primary menu in your WordPress site.
Version: 1.0.0
Author: anybuy.vn
Author URI: http://anybuy.vn/
*/
add_action('admin_menu', 'wpdvbn_admin_actions');
function wpdvbn_admin(){
    require('wpdvbn_admin.php');
    exit;
}
function wpdvbn_admin_actions(){
    add_options_page('Dispaly vBulletin Node', 'Dispaly vBulletin Node', 1, 'DispalyvBulletinoNode', 'wpdvbn_admin');
}
global $vbdb, $vbdb_prefix, $oc_url;
$vbdb_host = get_option('vbdb_host');
$vbdb_name = get_option('vbdb_name');
$vbdb_user = get_option('vbdb_user');
$vbdb_pass = get_option('vbdb_pass');
$vbdb_prefix = get_option('vbdb_prefix');
$vbdb = new wpdb($vbdb_user,$vbdb_pass, $vbdb_name, $vbdb_host);
add_filter( 'wp_nav_menu_items', 'vb_node_display', 10, 2 );

function vb_node_display($menu, $args) {
	$args = (array)$args;
	if ('primary' == $args['theme_location']){
		$nodes = vb_get_nodes();
		foreach ($nodes as $node) {
		$menu .= '<li class="menu-item menu-item-type-taxonomy menu-item-object-category menu-item-has-children"><a href="'.$node['href'].'">'.$node['title'].'</a>';
		if ($node['children']){
			$menu .= '<ul class="sub-menu">';
			foreach ($node['children'] as $child) {
				$menu .= '<li class="menu-item menu-item-type-taxonomy menu-item-object-category"><a href="'.$child['href'].'">'.$child['title'].'</a></li>';
			}
			$menu .= '</ul>';
		}
		$menu .= '</li>';
		}
	}
	return $menu;
}

function vb_get_nodes(){
	$nodes = vb_get_child_nodes(1);
	foreach ($nodes as $node) {
		$children_data = array();
		$children = vb_get_child_nodes($node['nodeid']);
		foreach ($children as $child){
			$children_data[] = array(
				'nodeid' => $child['nodeid'],
				'title'        => $child['title'],
				'href'        => vb_get_node_url($child['nodeid'], $child['urlident'])	
			);		
		}
		$data_nodes[] = array(
			'node_id' => $node['nodeid'],
			'title'        => $node['title'],
			'children'    => $children_data,
			'href'        => vb_get_node_url($node['nodeid'], $node['urlident'])
		);	
	}
	return($data_nodes);
}

function vb_get_child_nodes($parentid = 0) {
	global $vbdb, $vbdb_prefix;
	$nodes = $vbdb->get_results("SELECT * FROM " . $vbdb_prefix . "node WHERE parentid = '" . (int)$parentid . "' AND inlist = '1' ORDER BY displayorder ASC",ARRAY_A);
	return $nodes;
}

function vb_get_node_url($nodeid, $urlident) {
	global $vbdb, $vbdb_prefix;
	$vb_forum_url = get_option('vb_forum_url');
	$vb_seo_enabled = get_option('vb_seo_enabled');
	$query = $vbdb->get_results("SELECT * FROM " . $vbdb_prefix . "node WHERE nodeid = '" . (int)$nodeid . "'",ARRAY_A);
	$url = '';
	$parentid = $query[0]['parentid'];
	while($parentid >0){ 
		$node = $vbdb->get_results("SELECT * FROM " . $vbdb_prefix . "node WHERE nodeid = '" . (int)$parentid . "' AND inlist = '1' ORDER BY displayorder ASC",ARRAY_A);
		$url = $node[0]['urlident'].'/'.$url;		
		$parentid = $node[0]['parentid'];
	}
	$url = $vb_forum_url . $url . $urlident .'/';	
	$url = str_replace('//','/',$url);
	$url = str_replace(':/','://',$url);
	return $url;
}
?>